<template>
  <el-dialog
    :title="title"
    :visible.sync="dialogVisible"
    width="80%"
    :before-close="handleClose">
    <el-form ref="form" :model="form" :rules="rules" label-width="135px">
      <el-form-item label="所属管道" prop="pipeCode">
        <el-input v-model="form.pipeCode" placeholder="请输入所属管道" />
      </el-form-item>
      <el-form-item label="设备名称" prop="deviceName">
        <el-input v-model="form.deviceName" placeholder="请输入设备名称" />
      </el-form-item>
      <el-form-item label="所在地址" prop="deviceAddr">
        <el-input v-model="form.deviceAddr" placeholder="请输入所在地址" />
      </el-form-item>
      <el-form-item label="设备型号" prop="deviceModel">
        <el-input v-model="form.deviceModel" placeholder="请输入设备型号" />
      </el-form-item>
      <el-form-item label="经度" prop="longitude">
        <el-input v-model="form.longitude" placeholder="请输入经度" />
      </el-form-item>
      <el-form-item label="纬度" prop="latitude">
        <el-input v-model="form.latitude" placeholder="请输入纬度" />
      </el-form-item>
      <el-form-item label="物联网编号" prop="iotNo">
        <el-input v-model="form.iotNo" placeholder="请输入物联网编号" />
      </el-form-item>
      <el-form-item label="设备图片上传" prop="iconUrl">
        <MyFileUpload
          listType="picture-card"
          @resFun="getFileInfo"
          @remove="listRemove"
          :fileArr="fileArr"
        />
      </el-form-item>
      <el-form-item label="联系人" prop="linkman">
        <el-input v-model="form.linkman" placeholder="请输入联系人" />
      </el-form-item>
      <el-form-item label="电话" prop="phone">
        <el-input v-model="form.phone" placeholder="请输入电话" />
      </el-form-item>
      <el-form-item label="安装时间" prop="installationTime">
        <el-date-picker clearable size="small"
                        v-model="form.installationTime"
                        type="datetime"
                        value-format="yyyy-MM-dd HH:mm:ss"
                        placeholder="选择安装时间">
        </el-date-picker>
      </el-form-item>
      <el-form-item label="备注" prop="remarks">
        <el-input v-model="form.remarks" placeholder="请输入备注" />
      </el-form-item>
    </el-form>
    <span slot="footer" class="dialog-footer">
      <el-button @click="dialogVisible = false">取 消</el-button>
      <el-button type="primary" @click="submitForm">确 定</el-button>
    </span>
  </el-dialog>
</template>

<script>

  import { getAllDeviceInfo ,addDeviceInfo, updateDeviceInfo } from "@/api/device/deviceInfo";

  import MyFileUpload from "@/components/MyFileUpload";

  import { DEVICE_TYPE } from "utils/gaodeMap.js";

  export default {
    props: {
      title: { type: String }
    },
    data () {
      return {
        form : {
          deviceType : "3"
        },
        dialogVisible : false,
        fileList: [],
        // 表单校验
        rules: {
        },
        map : null,
        obj : null,
        gaoMap : null,
        fileArr: []
      }
    },
    components: {
      MyFileUpload,
    },
    methods: {
      show () {
        this.dialogVisible = true;
      },
      hide () {
        this.remove()
      },
      getFileInfo(res){
        this.form.iconUrl = res.url;
      },
      submitForm() {
        this.$refs["form"].validate(valid => {
          if (valid) {
            if (this.form.deviceId != null) {
              updateDeviceInfo(this.form).then(response => {
                this.dialogVisible = false;
                this.map.remove(this.obj);
                this.gaoMap.addMarker(this.gaoMap.deviceType,this.form);
                this.msgSuccess("修改成功");
              });
            } else {
              addDeviceInfo(this.form).then(response => {
                if(response.code == 200){
                  this.remove();
                  this.map.remove(this.obj);
                  this.form.deviceId = response.data;
                  this.gaoMap.addMarker(this.gaoMap.deviceType,this.form);
                  this.gaoMap.placeSearch.clear();
                  this.gaoMap.closeAddMarker();
                  this.msgSuccess("新增成功");
                }else{
                  this.msgSuccess("新增失败");
                }
              });
            }
          }
        });
      },
      handleClose(done) {
        done();
      },
      listRemove(e) {
        this.form.url = "";
        this.fileArr = [];
      }
    }
  }
</script>


